## bmake 20131001

=== Makefile ===
#	$Id: Makefile,v 1.21 2013/10/01 15:44:05 sjg Exp $

# Base version on src date
MAKE_VERSION= 20131001

PROG=	bmake

SRCS= \
	arch.c \
	buf.c \
	compat.c \
	cond.c \
	dir.c \
	for.c \
	hash.c \
	job.c \
	main.c \
	make.c \
	make_malloc.c \
	meta.c \
	parse.c \
	str.c \
	strlist.c \
	suff.c \
	targ.c \
	trace.c \
	util.c \
	var.c

# from lst.lib/
SRCS+= \
	lstAppend.c \
	lstAtEnd.c \
	lstAtFront.c \
	lstClose.c \
	lstConcat.c \
	lstDatum.c \
	lstDeQueue.c \
	lstDestroy.c \
	lstDupl.c \
	lstEnQueue.c \
	lstFind.c \
	lstFindFrom.c \
	lstFirst.c \
	lstForEach.c \
	lstForEachFrom.c \
	lstInit.c \
	lstInsert.c \
	lstIsAtEnd.c \
	lstIsEmpty.c \
	lstLast.c \
	lstMember.c \
	lstNext.c \
	lstOpen.c \
	lstPrev.c \
	lstRemove.c \
	lstReplace.c \
	lstSucc.c

# this file gets generated by configure
.-include "Makefile.config"

.if !empty(LIBOBJS)
SRCS+= ${LIBOBJS:T:.o=.c}
.endif

# just in case
prefix?= /usr
srcdir?= ${.CURDIR}

DEFAULT_SYS_PATH?= .../share/mk:${prefix}/share/mk

CPPFLAGS+= -DUSE_META
CFLAGS+= ${CPPFLAGS}
CFLAGS+= -D_PATH_DEFSYSPATH=\"${DEFAULT_SYS_PATH}\"
CFLAGS+= -I. -I${srcdir} ${XDEFS} -DMAKE_NATIVE
CFLAGS+= ${COPTS.${.ALLSRC:M*.c:T:u}}
COPTS.main.c+= "-DMAKE_VERSION=\"${MAKE_VERSION}\""

# meta mode can be useful even without filemon 
FILEMON_H ?= /usr/include/dev/filemon/filemon.h
.if exists(${FILEMON_H}) && ${FILEMON_H:T} == "filemon.h"
COPTS.meta.c += -DHAVE_FILEMON_H -I${FILEMON_H:H}
.endif

.PATH:	${srcdir}
.PATH:	${srcdir}/lst.lib

.if make(obj) || make(clean)
SUBDIR+= unit-tests
.endif

# start-delete1 for bsd.after-import.mk
# we skip a lot of this when building as part of FreeBSD etc.

# list of OS's which are derrived from BSD4.4
BSD44_LIST= NetBSD FreeBSD OpenBSD DragonFly
# we are...
OS!= uname -s
# are we 4.4BSD ?
isBSD44:=${BSD44_LIST:M${OS}}

.if ${isBSD44} == ""
MANTARGET= cat
INSTALL?=${srcdir}/install-sh
.if (${MACHINE} == "sun386")
# even I don't have one of these anymore :-)
CFLAGS+= -DPORTAR
.elif (${MACHINE} != "sunos")
SRCS+= sigcompat.c
CFLAGS+= -DSIGNAL_FLAGS=SA_RESTART
.endif
.else
MANTARGET?= man
.endif

# turn this on by default - ignored if we are root
WITH_INSTALL_AS_USER=

# supress with -DWITHOUT_*
OPTIONS_DEFAULT_YES+= \
	AUTOCONF_MK \
	INSTALL_MK \
	PROG_LINK

OPTIONS_DEFAULT_NO+= \
	PROG_VERSION

# process options now
.include <own.mk>

.if ${MK_PROG_VERSION} == "yes"
PROG_NAME= ${PROG}-${MAKE_VERSION}
.if ${MK_PROG_LINK} == "yes"
SYMLINKS+= ${PROG}-${MAKE_VERSION} ${BINDIR}/${PROG}
.endif
.endif

EXTRACT_MAN=no
# end-delete1

MAN= ${PROG}.1
MAN1= ${MAN}

.if (${PROG} != "make")
CLEANFILES+= my.history
.if make(${MAN}) || !exists(${srcdir}/${MAN})
my.history: ${MAKEFILE}
	@(echo ".Nm"; \
	echo "is derived from NetBSD"; \
	echo ".Xr make 1 ."; \
	echo "It uses autoconf to facilitate portability to other platforms."; \
	echo ".Pp") > $@

.NOPATH: ${MAN}
${MAN}:	make.1 my.history
	@echo making $@
	@sed -e 's/^.Nx/NetBSD/' -e '/^.Nm/s/make/${PROG}/' \
	-e '/^.Sh HISTORY/rmy.history' \
	-e '/^.Sh HISTORY/,$$s,^.Nm,make,' ${srcdir}/make.1 > $@

all beforeinstall: ${MAN}
_mfromdir=.
.endif
.endif

MANTARGET?= cat
MANDEST?= ${MANDIR}/${MANTARGET}1

.if ${MANTARGET} == "cat"
_mfromdir=${srcdir}
.endif

.include <prog.mk>

CPPFLAGS+= -DMAKE_NATIVE -DHAVE_CONFIG_H
COPTS.var.c += -Wno-cast-qual
COPTS.job.c += -Wno-format-nonliteral
COPTS.parse.c += -Wno-format-nonliteral
COPTS.var.c += -Wno-format-nonliteral

# Force these
SHAREDIR= ${prefix}/share
BINDIR= ${prefix}/bin
MANDIR= ${SHAREDIR}/man

.if !exists(.depend)
${OBJS}: config.h
.endif

# make sure that MAKE_VERSION gets updated.
main.o: ${SRCS} ${MAKEFILE}

# start-delete2 for bsd.after-import.mk
.if ${MK_AUTOCONF_MK} == "yes"
.include <autoconf.mk>
.endif
SHARE_MK?=${SHAREDIR}/mk
MKSRC=${srcdir}/mk
INSTALL?=${srcdir}/install-sh

.if ${MK_INSTALL_MK} == "yes"
install: install-mk
.endif

beforeinstall:
	test -d ${DESTDIR}${BINDIR} || ${INSTALL} -m 775 -d ${DESTDIR}${BINDIR}
	test -d ${DESTDIR}${MANDEST} || ${INSTALL} -m 775 -d ${DESTDIR}${MANDEST}

install-mk:
.if exists(${MKSRC}/install-mk)
	test -d ${DESTDIR}${SHARE_MK} || ${INSTALL} -m 775 -d ${DESTDIR}${SHARE_MK}
	sh ${MKSRC}/install-mk -v -m 644 ${DESTDIR}${SHARE_MK}
.else
	@echo need to unpack mk.tar.gz under ${srcdir} or set MKSRC; false
.endif
# end-delete2

# A simple unit-test driver to help catch regressions
accept test:
	cd ${.CURDIR}/unit-tests && MAKEFLAGS= ${.MAKE} -r -m / TEST_MAKE=${TEST_MAKE:U${.OBJDIR}/${PROG:T}} ${.TARGET}

=== debian/changelog ===
bmake (20131001-4) unstable; urgency=low

  * Don't include OS prefix in MACHINE_ARCH (Closes: #735856, patch by
    Robert Millan).

 -- Andrew Shadura <andrewsh@debian.org>  Sat, 18 Jan 2014 03:17:05 +0100

bmake (20131001-3) unstable; urgency=low

  * Add patch to fix segfault in hash.c, drop old var.c patch.

 -- Andrew Shadura <andrewsh@debian.org>  Sat, 04 Jan 2014 16:21:42 +0100

bmake (20131001-2) unstable; urgency=low

  * Check for sysctl(2) presence (unbreaks build for Hurd).
  * Clean up pkgsrc mk files:
    - Set correct MACHINE_GNU_PLATFORM.
    - Don't try to link against crtBegin.o explicitly.
    - Eliminate the need for a separate "debian" machine type.

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 31 Dec 2013 18:45:49 +0100

bmake (20131001-1) unstable; urgency=low

  * New upstream release.
  * Set MAKE_VERSION variable (Closes: #733654).
  * Update copyright information.
  * Drop old manpage patch, rename make(1) to bmake(1).
  * Set real OS variable in sys.mk.

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 31 Dec 2013 00:10:55 +0100

bmake (20130904-1) unstable; urgency=low

  * Rename the package to bmake, add a transitional package (Closes: #627983).
  * New upstream release

 -- Andrew Shadura <andrewsh@debian.org>  Sun, 22 Sep 2013 16:07:33 +0200

pmake (20130730-3) unstable; urgency=low

  * Disable MAKEFLAGS patch, apparently it breaks more than fixes.

 -- Andrew Shadura <andrewsh@debian.org>  Sun, 22 Sep 2013 15:31:06 +0200

pmake (20130730-2) unstable; urgency=low

  * Provide bmake.
  * Add buildsystem addon for debhelper.

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 15 Aug 2013 02:52:01 +0200

pmake (20130730-1) unstable; urgency=low

  * New maintainer.
  * New release based on bmake-20130730.
  * The main binary is now bmake, pmake is a compatibility symlink.
  * Use debhelper 9.
  * Bump Standards-Version to 3.9.4.

 -- Andrew Shadura <andrewsh@debian.org>  Wed, 14 Aug 2013 22:55:06 +0200

pmake (1.111-3.3) unstable; urgency=low

  * Non-maintainer upload.
  * Mark pmake as Multi-Arch: foreign.  The default configuration does
    differ on different architectures, but it can be overridden by setting
    MACHINE_ARCH and MACHINE_MULTIARCH (closes: #694907).
  * Use correct compiler when cross-building (closes: #694909).

 -- Colin Watson <cjwatson@debian.org>  Tue, 04 Jun 2013 11:27:37 +0100

pmake (1.111-3.2) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "powerpc and sparc64 considered as incomplete"
    Patch by Aurelien Jarno
    Closes: 640919

 -- Anibal Monsalve Salazar <anibal@debian.org>  Thu, 22 Sep 2011 08:39:25 +1000

pmake (1.111-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix missing -Wl for linker arguments
    Patch by Guillem Jover
    Closes: 628677

 -- Anibal Monsalve Salazar <anibal@debian.org>  Sat, 25 Jun 2011 18:55:30 +1000

pmake (1.111-3) unstable; urgency=low

  * 100_mk.diff: prepend -Wl for linker-only flags (Closes: 610516).
  * 140_multiarch.diff: new patch for multiarch, courtesy of Guillem Jover;
    fixes hardcoded paths (Closes: #626877).
  * 150_mktemp.diff: new patch, replace insecure temporary file handling with
    proper mktemp use, courtesy of Matej Vela (Closes: 626673).

 -- Sam Hocevar <sho@debian.org>  Sun, 29 May 2011 15:44:08 +0200

pmake (1.111-2) unstable; urgency=low

  [ Sam Hocevar <sho@debian.org> ]
  * Switch package to 3.0 (quilt) format.
  * debian/patches: rough split of the old patch.
  * debian/control: set policy to 3.8.3.

  [ Thorsten Glaser <tg@mirbsd.de> ]
  * Port to hurd-i386 (Closes: #547459)
    - make.h: define MAXPATHLEN if not defined (XXX kludge)
    - main.c: check sysconf(_PC_PATH_MAX) and bail out if larger than
      the defined kludge value; inform the user appropriately
    I’m doing it this way because this codebase is ancient, and to
    really fix this issue is not worth the effort. No activity in
    more than four years speaks for itself.
  * mk/sys.mk: We do not run NetBSD® but Debian. (Closes: #493839)
  * debian/rules: Replace 「dpkg --print-gnu-build-architecture」 with
    「dpkg-architecture -qDEB_HOST_ARCH_CPU」 to unbreak build.
  * debian/rules: Use -Wno-unused to clean up build messages.

 -- Sam Hocevar <sho@debian.org>  Mon, 21 Dec 2009 22:43:44 +0100

pmake (1.111-1) unstable; urgency=low

  * New upstream snapshot.
  * This version properly parses arguments and does not crash when parameters
    are missing (Closes: #287336, #316394).
  * debian/control:
    + Set policy to 3.6.2.1.

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Thu,  7 Jul 2005 10:20:56 +0200

pmake (1.98-3) unstable; urgency=low

  * mk/bsd.man.mk:
    + Use symlinks instead of hard links when using the MLINKS directive
      to link manual pages, courtesy of Robert Millan.

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Fri, 12 Mar 2004 13:14:27 +0100

pmake (1.98-2) unstable; urgency=low

  * buf.c:
    + Work around a GCC 3 ICE on hppa.

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Wed, 10 Mar 2004 18:43:16 +0100

pmake (1.98-1) unstable; urgency=low

  * New maintainer (Closes: #218804).
  * New upstream version from NetBSD HEAD (Closes: #134798).
  * Moved to a non-native package.
  * debian/rules:
    + Switched to debhelper.
  * main.c:
    + Parse $MAKE instead of $MAKEFLAGS when called from GNU make to avoid
      strange interactions (Closes: #189097).

 -- Sam Hocevar (Debian packages) <sam+deb@zoy.org>  Fri, 27 Feb 2004 16:04:12 +0100

pmake (1.45-11) unstable; urgency=low

  * Set defaults to match policy better. Closes: #150895. Thanks to 
    Matej Vela for the patch.

 -- Steve McIntyre <93sam@debian.org>  Sun, 30 Jun 2002 23:52:31 +0100

pmake (1.45-10) unstable; urgency=low

  * Fixed broken '.Nm ""' directives in the man page. Closes: #137768
  * Changed name from "make" to "pmake" in manpage.

 -- Steve McIntyre <93sam@debian.org>  Tue, 12 Mar 2002 21:59:55 +0000

pmake (1.45-9) unstable; urgency=low



=== debian/control ===
Source: bmake
Section: devel
Priority: optional
Maintainer: Andrew Shadura <andrewsh@debian.org>
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9), groff, dh-autoreconf
Homepage: http://www.crufty.net/help/sjg/bmake.html

Package: bmake
Architecture: any
Multi-Arch: foreign
Replaces: pmake
Provides: pmake
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NetBSD make
 bmake is a program designed to simplify the maintenance of other
 programs. Its input is a list of specifications as to the files upon
 which programs and other files depend.  mkdep, a program to construct
 Makefile dependency lists, is also included.
 .
 bmake is a port of the NetBSD make tool.

Package: pmake
Architecture: all
Depends: bmake, ${misc:Depends}
Description: NetBSD make (transitional package)
 This is a dummy package to aid in transitioning from pmake package
 to the new bmake package.
 .
 This dummy package may be safely removed after upgrading.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
MAKE_VERSION=$(shell sed -n '/^MAKE_VERSION=/s,.*=[^0-9]*,,p' Makefile)
CFLAGS=$(shell dpkg-buildflags --get CFLAGS) \
	-D__COPYRIGHT\(x\)= -D__RCSID\(x\)= \
	-I. -DMACHINE=\\\"debian\\\" -DMACHINE_ARCH=\\\"${ARCH}\\\" \
	-DMACHINE_MULTIARCH=\\\"${MULTIARCH}\\\" \
	-DHAVE_CONFIG_H -DNEED_HOST_CDEFS_H -DMAKE_NATIVE \
	-DUSE_META -D_PATH_DEFSYSPATH=\\\"/usr/share/mk\\\" \
	-DMAKE_VERSION=\\\"${MAKE_VERSION}\\\" \
	-Wno-unused

DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
CROSS :=
else
CROSS := CC=$(DEB_HOST_GNU_TYPE)-gcc
endif

%:
	dh $@ --with=autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-machine=debian

override_dh_auto_build:
	$(MAKE) -f Makefile.boot CFLAGS="$(CFLAGS) $(CPPFLAGS)" LIBS="$(LDFLAGS)" $(CROSS)

override_dh_auto_test:

override_dh_auto_clean:
	$(MAKE) -f Makefile.boot clean

override_dh_auto_install:
	ln -s bmake pmake
	groff -Tascii -ms PSD.doc/tutorial.ms > \
	      PSD.doc/tutorial.asc
	groff -Tps -ms PSD.doc/tutorial.ms > \
	      PSD.doc/tutorial.ps

.PHONY: override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_clean override_dh_auto_install

## bmake 20140620

=== debian/changelog ===
bmake (20140620-1) unstable; urgency=medium

  * New upstream release.
  * Set MACHINE_ARCH to mipseb on mips (Closes: #754416).

 -- Andrew Shadura <andrewsh@debian.org>  Sat, 12 Jul 2014 08:50:55 +0200

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 #export DH_VERBOSE=1
 
-ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
+ARCH=$(patsubst mips,mipseb,$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU))
 MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 MAKE_VERSION=$(shell sed -n '/^MAKE_VERSION=/s,.*=[^0-9]*,,p' Makefile)
 CFLAGS=$(shell dpkg-buildflags --get CFLAGS) \

## bmake 20150606

=== debian/changelog ===
bmake (20150606-1) unstable; urgency=medium

  * New upstream release.
  * Change dh helper to call autoconf when needed.

 -- Andrew Shadura <andrewsh@debian.org>  Sat, 25 Jul 2015 14:33:56 +0200

bmake (20140620-3) unstable; urgency=medium

  * Handle ‘undefined’ in the output of getconf (unbreaks Hurd build,
    thanks to Svante Signell; closes: #761666).

 -- Andrew Shadura <andrewsh@debian.org>  Tue, 16 Sep 2014 22:16:11 +0200

bmake (20140620-2) unstable; urgency=medium

  * Fix build on Hurd, drop old hacks.

 -- Andrew Shadura <andrewsh@debian.org>  Mon, 15 Sep 2014 17:57:20 +0200

## bmake 20160220

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
-#	$Id: Makefile,v 1.21 2013/10/01 15:44:05 sjg Exp $
+#	$Id: Makefile,v 1.53 2016/02/20 01:29:21 sjg Exp $
 
 # Base version on src date
-MAKE_VERSION= 20131001
+MAKE_VERSION= 20160220
 
 PROG=	bmake
 
@@ -18,6 +18,7 @@
 	make.c \
 	make_malloc.c \
 	meta.c \
+	metachar.c \
 	parse.c \
 	str.c \
 	strlist.c \
@@ -68,7 +69,7 @@
 prefix?= /usr
 srcdir?= ${.CURDIR}
 
-DEFAULT_SYS_PATH?= .../share/mk:${prefix}/share/mk
+DEFAULT_SYS_PATH?= ${prefix}/share/mk
 
 CPPFLAGS+= -DUSE_META
 CFLAGS+= ${CPPFLAGS}
@@ -94,7 +95,7 @@
 # we skip a lot of this when building as part of FreeBSD etc.
 
 # list of OS's which are derrived from BSD4.4
-BSD44_LIST= NetBSD FreeBSD OpenBSD DragonFly
+BSD44_LIST= NetBSD FreeBSD OpenBSD DragonFly MirBSD Bitrig
 # we are...
 OS!= uname -s
 # are we 4.4BSD ?
@@ -117,7 +118,7 @@
 # turn this on by default - ignored if we are root
 WITH_INSTALL_AS_USER=
 
-# supress with -DWITHOUT_*
+# suppress with -DWITHOUT_*
 OPTIONS_DEFAULT_YES+= \
 	AUTOCONF_MK \
 	INSTALL_MK \
@@ -180,9 +181,9 @@
 COPTS.var.c += -Wno-format-nonliteral
 
 # Force these
-SHAREDIR= ${prefix}/share
-BINDIR= ${prefix}/bin
-MANDIR= ${SHAREDIR}/man
+SHAREDIR= ${SHAREDIR.bmake:U${prefix}/share}
+BINDIR= ${BINDIR.bmake:U${prefix}/bin}
+MANDIR= ${MANDIR.bmake:U${SHAREDIR}/man}
 
 .if !exists(.depend)
 ${OBJS}: config.h

=== debian/changelog ===
bmake (20160220-2) unstable; urgency=medium

  * Add README.Debian.

 -- Andrew Shadura <andrewsh@debian.org>  Sun, 06 Mar 2016 10:48:24 +0100

bmake (20160220-1) unstable; urgency=medium

  * New upstream release.
  * Add cleandir support to the dh helper.

 -- Andrew Shadura <andrewsh@debian.org>  Sun, 06 Mar 2016 10:26:15 +0100

bmake (20150606-2) unstable; urgency=medium

  * Fix a bug in the dh helper.

 -- Andrew Shadura <andrewsh@debian.org>  Sat, 05 Mar 2016 16:29:33 +0100

=== debian/rules ===
--- 
+++ 
@@ -29,7 +29,7 @@
 	dh_auto_configure -- --with-machine=debian
 
 override_dh_auto_build:
-	$(MAKE) -f Makefile.boot CFLAGS="$(CFLAGS) $(CPPFLAGS)" LIBS="$(LDFLAGS)" $(CROSS)
+	$(MAKE) -f Makefile.boot CFLAGS="$(CFLAGS)" $(CROSS)
 
 override_dh_auto_test:

=== debian/watch ===
version=3
#http://ftp.netbsd.org/pub/NetBSD/misc/sjg/bmake-(\d{8})\.tar\.gz
http://crufty.net/ftp/pub/sjg/bmake-(.*)\.tar\.gz

## bmake 20181221

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,4 @@
-#	$Id: Makefile,v 1.53 2016/02/20 01:29:21 sjg Exp $
-
-# Base version on src date
-MAKE_VERSION= 20160220
+#	$Id: Makefile,v 1.99 2017/08/13 20:12:53 sjg Exp $
 
 PROG=	bmake
 
@@ -58,6 +55,8 @@
 	lstReplace.c \
 	lstSucc.c
 
+.-include "VERSION"
+
 # this file gets generated by configure
 .-include "Makefile.config"
 
@@ -76,7 +75,7 @@
 CFLAGS+= -D_PATH_DEFSYSPATH=\"${DEFAULT_SYS_PATH}\"
 CFLAGS+= -I. -I${srcdir} ${XDEFS} -DMAKE_NATIVE
 CFLAGS+= ${COPTS.${.ALLSRC:M*.c:T:u}}
-COPTS.main.c+= "-DMAKE_VERSION=\"${MAKE_VERSION}\""
+COPTS.main.c+= "-DMAKE_VERSION=\"${_MAKE_VERSION}\""
 
 # meta mode can be useful even without filemon 
 FILEMON_H ?= /usr/include/dev/filemon/filemon.h
@@ -131,9 +130,9 @@
 .include <own.mk>
 
 .if ${MK_PROG_VERSION} == "yes"
-PROG_NAME= ${PROG}-${MAKE_VERSION}
+PROG_NAME= ${PROG}-${_MAKE_VERSION}
 .if ${MK_PROG_LINK} == "yes"
-SYMLINKS+= ${PROG}-${MAKE_VERSION} ${BINDIR}/${PROG}
+SYMLINKS+= ${PROG_NAME} ${BINDIR}/${PROG}
 .endif
 .endif
 
@@ -156,7 +155,10 @@
 .NOPATH: ${MAN}
 ${MAN}:	make.1 my.history
 	@echo making $@
-	@sed -e 's/^.Nx/NetBSD/' -e '/^.Nm/s/make/${PROG}/' \
+	@sed \
+	-e '/^.Dt/s/MAKE/${PROG:tu}/' \
+	-e 's/^.Nx/NetBSD/' \
+	-e '/^.Nm/s/make/${PROG}/' \
 	-e '/^.Sh HISTORY/rmy.history' \
 	-e '/^.Sh HISTORY/,$$s,^.Nm,make,' ${srcdir}/make.1 > $@
 
@@ -189,11 +191,13 @@
 ${OBJS}: config.h
 .endif
 
+# start-delete2 for bsd.after-import.mk
+
 # make sure that MAKE_VERSION gets updated.
-main.o: ${SRCS} ${MAKEFILE}
-
-# start-delete2 for bsd.after-import.mk
+main.o: ${SRCS} ${.CURDIR}/VERSION
+
 .if ${MK_AUTOCONF_MK} == "yes"
+CONFIGURE_DEPS += ${.CURDIR}/VERSION
 .include <autoconf.mk>
 .endif
 SHARE_MK?=${SHAREDIR}/mk

=== debian/changelog ===
bmake (20181221-2) unstable; urgency=high

  * Fix MAKE_VERSION detection.
  * Add a guard rules to prevent bmake with empty MAKE_VERSION
    from being uploaded.
  * Use debhelper-compat instead of debian/compat.
  * Trim trailing whitespace.
  * Drop no longer supported add-log-mailing-address setting from
    debian/changelog.
  * Bump debhelper from old 9 to 12.
  * Move transitional package pmake to oldlibs/optional per policy
    4.0.1.
  * Set upstream metadata fields: Bug-Submit.
  * Drop unnecessary dependency on dh-autoconf.
  * Bump Standards-Version.
  * Update maintainer’s name.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 20 Jan 2020 16:39:48 +0100

bmake (20181221-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces
  * d/control: Add Vcs-* field

  [ Andrej Shadura ]
  * New upstream release.

  [ Philippe Grégoire ]
  * Add the appropriate -Wl flag for -soname (Closes: #821752).

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 19 Dec 2019 16:16:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: bmake
 Section: devel
 Priority: optional
-Maintainer: Andrew Shadura <andrewsh@debian.org>
-Standards-Version: 3.9.4
-Build-Depends: debhelper (>= 9), groff, dh-autoreconf
+Maintainer: Andrej Shadura <andrewsh@debian.org>
+Standards-Version: 4.4.1
+Build-Depends: debhelper-compat (= 12), groff
 Homepage: http://www.crufty.net/help/sjg/bmake.html
+Vcs-Browser: https://salsa.debian.org/debian/bmake
+Vcs-Git: https://salsa.debian.org/debian/bmake.git
 
 Package: bmake
 Architecture: any
@@ -28,4 +30,4 @@
  to the new bmake package.
  .
  This dummy package may be safely removed after upgrading.
-
+Section: oldlibs

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 ARCH=$(patsubst mips,mipseb,$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU))
 MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
-MAKE_VERSION=$(shell sed -n '/^MAKE_VERSION=/s,.*=[^0-9]*,,p' Makefile)
+MAKE_VERSION=$(shell sed -n -e '/MAKE_VERSION=[^0-9]*[0-9]/s,.*=[^0-9]*,,p' Makefile VERSION)
 CFLAGS=$(shell dpkg-buildflags --get CFLAGS) \
 	-D__COPYRIGHT\(x\)= -D__RCSID\(x\)= \
 	-I. -DMACHINE=\\\"debian\\\" -DMACHINE_ARCH=\\\"${ARCH}\\\" \
@@ -23,9 +23,10 @@
 endif
 
 %:
-	dh $@ --with=autoreconf
+	dh $@
 
 override_dh_auto_configure:
+	@[ -n "$(MAKE_VERSION)" ] || ( echo MAKE_VERSION not defined && exit 1 )
 	dh_auto_configure -- --with-machine=debian
 
 override_dh_auto_build:

## bmake 20200710

=== unit-tests/Makefile ===
# $Id: Makefile,v 1.60 2020/07/10 00:48:32 sjg Exp $
#
# $NetBSD: Makefile,v 1.63 2020/07/09 22:40:14 sjg Exp $
#
# Unit tests for make(1)
#
# The main targets are:
#
# all:
#	run all the tests
# test:
#	run 'all', and compare to expected results
# accept:
#	move generated output to expected results
#
# Settable variables
#
# TEST_MAKE
#	The make program to be tested.
#
#
# Adding a test case
#
# Each feature should get its own set of tests in its own suitably
# named makefile (*.mk), with its own set of expected results (*.exp),
# and it should be added to the TESTS list.
#
# Any added files must also be added to src/distrib/sets/lists/tests/mi.
# Makefiles that are not added to TESTS must be ignored in
# src/tests/usr.bin/make/t_make.sh (example: include-sub).
#

# Each test is in a sub-makefile.
# Keep the list sorted.
TESTS+=		comment
TESTS+=		cond-late
TESTS+=		cond-short
TESTS+=		cond1
TESTS+=		cond2
TESTS+=		dollar
TESTS+=		doterror
TESTS+=		dotwait
TESTS+=		error
TESTS+=		# escape	# broken by reverting POSIX changes
TESTS+=		export
TESTS+=		export-all
TESTS+=		export-env
TESTS+=		forloop
TESTS+=		forsubst
TESTS+=		hash
TESTS+=		# impsrc	# broken by reverting POSIX changes
TESTS+=		include-main
TESTS+=		misc
TESTS+=		moderrs
TESTS+=		modmatch
TESTS+=		modmisc
TESTS+=		modorder
TESTS+=		modts
TESTS+=		modword
TESTS+=		order
TESTS+=		# phony-end	# broken by reverting POSIX changes
TESTS+=		posix
TESTS+=		# posix1	# broken by reverting POSIX changes
TESTS+=		qequals
TESTS+=		# suffixes	# broken by reverting POSIX changes
TESTS+=		sunshcmd
TESTS+=		sysv
TESTS+=		ternary
TESTS+=		unexport
TESTS+=		unexport-env
TESTS+=		varcmd
TESTS+=		varmisc
TESTS+=		varmod-edge
TESTS+=		varquote
TESTS+=		varshell

# Override make flags for certain tests; default is -k.
FLAGS.doterror=		# none
FLAGS.order=		-j1

# Some tests need extra post-processing.
SED_CMDS.modmisc+=	-e 's,\(substitution error:\).*,\1 (details omitted),'
SED_CMDS.varshell+=	-e 's,^[a-z]*sh: ,,'
SED_CMDS.varshell+=	-e '/command/s,No such.*,not found,'

# End of the configuration section.

.MAIN: all

.-include "Makefile.config"

UNIT_TESTS:=	${.PARSEDIR}
.PATH: ${UNIT_TESTS}

OUTFILES=	${TESTS:=.out}

all: ${OUTFILES}

CLEANFILES+=		*.rawout *.out *.status *.tmp *.core *.tmp
CLEANFILES+=		obj*.[och] lib*.a	# posix1.mk
CLEANFILES+=		issue* .[ab]*		# suffixes.mk
CLEANRECURSIVE+=	dir dummy		# posix1.mk

clean:
	rm -f ${CLEANFILES}
.if !empty(CLEANRECURSIVE)
	rm -rf ${CLEANRECURSIVE}
.endif

TEST_MAKE?=	${.MAKE}
TOOL_SED?=	sed
TOOL_TR?=	tr
TOOL_DIFF?=	diff
DIFF_FLAGS?=	-u

.if defined(.PARSEDIR)
# ensure consistent results from sort(1)
LC_ALL=		C
LANG=		C
.export LANG LC_ALL
.endif

# the tests are actually done with sub-makes.
.SUFFIXES: .mk .rawout .out
.mk.rawout:
	@echo ${TEST_MAKE} ${FLAGS.${.TARGET:R}:U-k} -f ${.IMPSRC}
	-@cd ${.OBJDIR} && \
	{ ${TEST_MAKE} ${FLAGS.${.TARGET:R}:U-k} -f ${.IMPSRC} \
	  2>&1 ; echo $$? >${.TARGET:R}.status ; } > ${.TARGET}.tmp
	@mv ${.TARGET}.tmp ${.TARGET}

# Post-process the test output so that the results can be compared.
#
# always pretend .MAKE was called 'make'
_SED_CMDS+=	-e 's,^${TEST_MAKE:T:S,.,\\.,g}[][0-9]*:,make:,'
_SED_CMDS+=	-e 's,${TEST_MAKE:S,.,\\.,g},make,'
# replace anything after 'stopped in' with unit-tests
_SED_CMDS+=	-e '/stopped/s, /.*, unit-tests,'
# strip ${.CURDIR}/ from the output
_SED_CMDS+=	-e 's,${.CURDIR:S,.,\\.,g}/,,g'
_SED_CMDS+=	-e 's,${UNIT_TESTS:S,.,\\.,g}/,,g'

.rawout.out:
	@echo postprocess ${.TARGET}
	@${TOOL_SED} ${_SED_CMDS} ${SED_CMDS.${.TARGET:R}} \
	  < ${.IMPSRC} > ${.TARGET}.tmp
	@echo "exit status `cat ${.TARGET:R}.status`" >> ${.TARGET}.tmp
	@mv ${.TARGET}.tmp ${.TARGET}

# Compare all output files
test:	${OUTFILES} .PHONY
	@failed= ; \
	for test in ${TESTS}; do \
	  ${TOOL_DIFF} ${DIFF_FLAGS} ${UNIT_TESTS}/$${test}.exp $${test}.out \
	  || failed="$${failed}$${failed:+ }$${test}" ; \
	done ; \
	if [ -n "$${failed}" ]; then \
	  echo "Failed tests: $${failed}" ; false ; \
	else \
	  echo "All tests passed" ; \
	fi

accept:
	@for test in ${TESTS}; do \
	  cmp -s ${UNIT_TESTS}/$${test}.exp $${test}.out \
	  || { echo "Replacing $${test}.exp" ; \
	       cp $${test}.out ${UNIT_TESTS}/$${test}.exp ; } \
	done

.if exists(${TEST_MAKE})
${TESTS:=.rawout}: ${TEST_MAKE}
.endif

.-include <obj.mk>

=== debian/changelog ===
bmake (20200710-17) unstable; urgency=medium

  * Sanitise MAKEFLAGS before passing them to bmake which does not
    support long options (Closes: #1109052).

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 13 Jul 2025 17:23:12 +0200

bmake (20200710-16) unstable; urgency=medium

  [ Debian Janitor ]
  * Use secure URI in debian/watch and Homepage field.
  * Update standards version to 4.6.1, no changes needed.

  [ Andrej Shadura ]
  * Pmake package is now really gone, drop Breaks+Replaces.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 29 Jun 2023 12:15:43 +0200

bmake (20200710-15) unstable; urgency=medium

  [ Boyuan Yang ]
  * Fix build with autoconf 2.70 (Closes: #978773).

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 30 Sep 2021 22:30:38 +0200

bmake (20200710-14) unstable; urgency=medium

  * Remove the bsd.*.mk autodetection now that we actually ship symlinks.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 02 Apr 2021 12:53:47 +0200

bmake (20200710-13) unstable; urgency=medium

  * Install bsd.*.mk symlinks similarly to what the upstream does
    (Closes: #986281)

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 02 Apr 2021 12:46:29 +0200

bmake (20200710-12) unstable; urgency=medium

  * Make sure debhelper is installed for the test it’s needed for.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 02 Apr 2021 10:56:28 +0200

bmake (20200710-11) unstable; urgency=medium

  * bmake.pm: Sanitise MAKEFLAGS before passing them to bmake
    (Closes: #906330).
  * Allow overriding testdir in tests through the environment.
  * Add a test for MAKEFLAGS sanitisation.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 01 Apr 2021 12:46:03 +0200

bmake (20200710-10) unstable; urgency=medium

  * Verify bmake returns exit code 2.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 18 Mar 2021 13:01:07 +0100

bmake (20200710-9) unstable; urgency=medium

  * Add autopkgtest to test both bmake and pmake are sane.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 18 Mar 2021 12:52:39 +0100

bmake (20200710-8) unstable; urgency=medium

  * preinst: Properly deal with other packages installing files under
    /usr/share/mk (Closes: #985347)
  * Fix day-of-week for changelog entry 1.45-7.
  * Update standards version to 4.5.0, no changes needed.

 -- Andrej Shadura <andrewsh@debian.org>  Tue, 16 Mar 2021 13:36:16 +0100

bmake (20200710-7) unstable; urgency=medium

  * bmake.pm: Drop autoconf support.
  * bmake.pm: Use .ALLTARGETS to verify the presence of targets.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 04 Feb 2021 20:49:27 +0100

bmake (20200710-6) unstable; urgency=medium

  * Move the NetBSD mk files to the new location (Closes: #975963).
  * Ship bmake makefiles as the default (Closes: #823185).
  * Provide a wrapper script for pmake (Closes: #966824).
  * Parse the bmake output in exists_make_target (Closes: #906330).
  * Provide a debhelper wrapper for pmake.
  * Detect Makefiles written for pmake and use pmake automatically.

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 31 Jan 2021 17:07:18 +0100

bmake (20200710-5) unstable; urgency=medium

  * Ship debian.mk as a symlink to Linux.mk in the bmake mk files

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 26 Jul 2020 21:08:24 +0200

bmake (20200710-4) unstable; urgency=medium

  * Ship NetBSD mk files as the default /usr/share/mk
    (Reopens: #823185).

 -- Andrej Shadura <andrewsh@debian.org>  Sun, 26 Jul 2020 20:54:25 +0200

bmake (20200710-3) unstable; urgency=medium

  * Don’t attempt to install pmake (fixes FTBFS).

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 25 Jul 2020 09:43:04 +0200

bmake (20200710-2) unstable; urgency=medium

  * No longer provide pmake.

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 24 Jul 2020 21:10:09 +0200

bmake (20200710-1) unstable; urgency=medium

  * New upstream release (Closes: #957047).
  * Refresh patches and rules.
  * Ship bmake mk files (Closes: #823185).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 24 Jul 2020 20:11:00 +0200

=== debian/tests/package-fixture/debian/changelog ===
package-fixture (0) UNRELEASED; urgency=medium

  * Nothing!

 -- Nobody <nobody@example.org>  Thu, 01 Apr 2021 00:00:00 +0000

=== debian/control ===
Source: bmake
Section: devel
Priority: optional
Maintainer: Andrej Shadura <andrewsh@debian.org>
Standards-Version: 4.6.1
Build-Depends: debhelper-compat (= 12), groff
Homepage: https://www.crufty.net/help/sjg/bmake.html
Vcs-Browser: https://salsa.debian.org/debian/bmake
Vcs-Git: https://salsa.debian.org/debian/bmake.git

Package: bmake
Architecture: any
Multi-Arch: foreign
Provides: pmake
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NetBSD make
 bmake is a program designed to simplify the maintenance of other
 programs. Its input is a list of specifications as to the files upon
 which programs and other files depend.  mkdep, a program to construct
 Makefile dependency lists, is also included.
 .
 bmake is a port of the NetBSD make tool.

=== debian/tests/package-fixture/debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=pmake

=== debian/watch ===
version=3
#http://ftp.netbsd.org/pub/NetBSD/misc/sjg/bmake-(\d{8})\.tar\.gz
https://www.crufty.net/ftp/pub/sjg/bmake-(.*)\.tar\.gz
